/*  wmrt v1.0 Copyright (C) 2003 tomasliq <tom@eggdrop.ch>
 *  
 *  rtserver.c -- remote traffic server for wmrt
 *
 *  This file is part of wmrt.
 *  For more information visit: http://www.eggdrop.ch/projects/wmrt/
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

/* TODO: CLEAN UP THIS SPAGHETTI CODE! */


#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/signal.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <unistd.h>
#include <time.h>
#include <string.h>

/* KVM */
#include <fcntl.h>
#include <net/if.h>
#include <kvm.h>
#include <nlist.h>

char buffer[256];

kvm_t *kvmfd;
struct nlist symbols[] = {
 { "_ifnet" },
 { NULL }
};
unsigned long ifnet_savedaddr;
int kvm_test(void);
int kvm_updatestats(void);
int db_in=0, db_out=0, last_db_in=0, last_db_out=0, rx=0, tx=0;

#define ACCOUNT_IN_FOUND        1
#define ACCOUNT_OUT_FOUND       2

/* ****** */

char DEVICE[128];
unsigned short PORT;


#define BUFSIZE 8192
#define MAXSOCKETS 1000

#define SOCK_LISTEN 0
#define SOCK_CONN 1

struct sock {
  int num; /* number of the socket */
  int numtype;
  int listenport;
  struct in_addr ip; /* ip address */
};

struct sock *socklist[MAXSOCKETS];
int socks=-1; 

void bcast(void);
int getsock(void);
int socklisten(struct sock *socket, unsigned short port);
void accept_socklisten_connections(void);
int accept_socklisten_connection (int s);
int newsocket(struct sock socket);
void closesocket(int x);
int getfreesocknum(void);
void initsocklist(void);
void listenp(unsigned short port);
void get_sockdata(void);
int main(int argc, char *argv[]);


/* send traffic */
void bcast(void)
{
	int x=0;
	char *str;
	int size;

	/* this buffer should be enough for 32-bit-machines */
             /* int */ /* space */ /* int */ /* \r\n */ /* \0 */
	size = 	11    +     1     +   11    +     2    +    1;

	str=malloc(size);
	snprintf(str, size, "%d %d\r\n", db_in-last_db_in, db_out-last_db_out);

	for(;x<MAXSOCKETS;x++)
	{
		if (socklist[x] != 0)
		{
			if (socklist[x]->numtype == SOCK_CONN)
			{
				if (send(socklist[x]->num, str, strlen(str), 0) < 0)
				{
					closesocket(x);
				}
			}
		}
	}
}


int getsock(void)
{
  int sock = socket(AF_INET, SOCK_STREAM, 0);
  if (sock < 0)
    printf("Error: Cannot create new socket!");
  return sock;
}

int socklisten(struct sock *socket, unsigned short port)
{
  struct sockaddr_in sin;
  int lsock = getsock();
  int x;

  if (lsock < 1) return -1;

  sin.sin_family = AF_INET;
  sin.sin_port = htons(port);
  sin.sin_addr.s_addr = INADDR_ANY;

  if (bind(lsock, (struct sockaddr *) &sin, sizeof(sin)) < 0)
    return -2;
  if (listen(lsock, 1) < 0) {
    close(lsock);
    return -3;
  }
  socket->num = lsock;
  socket->numtype = SOCK_LISTEN;
  socket->listenport = port;
  socket->ip                = sin.sin_addr;

  x = newsocket(*socket);
  if (x == -1)
  {
    close(lsock);
    return -4;
  }

  return x;
}

void accept_socklisten_connections(void)
{
  int x=0;
  for(;x<MAXSOCKETS;x++)
    if (socklist[x] != 0)
      if (socklist[x]->numtype == SOCK_LISTEN)
        accept_socklisten_connection(x);
}

int accept_socklisten_connection (int s)
{
  struct timeval tv;
  fd_set fds;
  int x, new_s, s_len;
  struct sockaddr_in sin;
  struct sock socket;

  s_len = sizeof(sin);

  tv.tv_sec = 0;
  tv.tv_usec = 0;

  FD_ZERO(&fds);
  FD_SET(socklist[s]->num, &fds);
  FD_SET(STDIN_FILENO, &fds);

  x = select(socklist[s]->num+1, &fds, NULL, NULL, &tv);

  if (x) /* there is a socket to accept (accept only one connection) */
  {
    /* char temp[50];
    char test[]="Test\n";
    int i=0; */
    int snum;

    new_s = accept(socklist[s]->num, (struct sockaddr *)&sin, &s_len);

    if (new_s < 0) return -1;

    socket.num       = new_s;
    socket.numtype   = SOCK_CONN;
    socket.ip        = sin.sin_addr;

    snum = newsocket(socket);
    if (snum == -1)
    {
      close(new_s);
      return -1;
    }

    printf("Connection from %s\n", inet_ntoa(sin.sin_addr));
    return 1;
  }
  return 0;
}
int newsocket(struct sock socket)
{
  int x;
  x = getfreesocknum();
  if (x == -1) return -1;
  socklist[x] = malloc(sizeof(struct sock));
  if (socklist[x] == NULL) { 
	printf("FATAL ERROR: No memory available!\n"); exit(1); 
  }
  *socklist[x] = socket;
  return x;
}

void closesocket(int x)
{
  close(socklist[x]->num);
  free(socklist[x]);
  socklist[x]=0;
}

int getfreesocknum(void)
{
  int x=0;
  for(;x<MAXSOCKETS;x++)
    if (socklist[x]==0) return x;
  return -1;
}

void initsocklist(void) /* this function does NOT clear the socklist! */
{
  int x=0;
  for(;x<MAXSOCKETS;x++)
    socklist[x]=0;
}

void listenp(unsigned short port)
{
  struct sock listen;
  int x=0, i=0;

  for(;i<MAXSOCKETS;i++)
    if (socklist[i]!=0)
      if (socklist[i]->numtype == SOCK_LISTEN)
        if (socklist[i]->listenport == port)
          return; 

  x=socklisten(&listen, port);

  if (x < 0)
    printf("Cannot listen on port %d\n", port);
  else
    printf("Listening on port %d\n", port);
}

void get_sockdata(void)
{
  int i,x;
  struct timeval tv;
  fd_set fds;
  char buffer[BUFSIZE];
  int bytes;
  int cnt=0; /* for continue */

  tv.tv_sec = 0;
  tv.tv_usec = 0;

  for(i=0;i<MAXSOCKETS;i++)
  {
    cnt=0;
    if (socklist[i]!=0)
    {
      if (socklist[i]->numtype == SOCK_CONN)
      {
        FD_ZERO(&fds);
        FD_SET(socklist[i]->num, &fds);
        FD_SET(STDIN_FILENO, &fds);

        x = select(socklist[i]->num+1, &fds, NULL, NULL, &tv);

        if (x)
        {
          buffer[0]='\0';
          if ((bytes = read(socklist[i]->num, buffer, sizeof(buffer))) == -1)
          { /* error */
            closesocket(i);
          }
          else
          {
            if (bytes == 0)
            { /* connection closed */
              closesocket(i);
            }
            else
            {
		/* received something, who cares? */
            }
          }
        }
      }
    }
  }
}

int main(int argc, char *argv[])
{
	int timenow, timelast;
	int timesecs=0;
	unsigned long started;

	if (argc != 3)
	{
		printf("Usage: %s <device> <port>\n", argv[0]);
		exit(1);
	}

	strncpy(DEVICE, argv[1], sizeof(DEVICE));
	PORT = (unsigned short)atoi(argv[2]);

	signal(SIGPIPE, SIG_IGN);

	started=time(NULL);
	initsocklist();
	listenp(PORT);
	timelast = time(NULL);

	if (kvm_test() != 1)
	{
		printf("Error: Cannot monitor device!\n");
		exit(1);
	}
	
	kvm_updatestats();

	while(1)
	{
		timenow = time(NULL);
		if (timenow != timelast)
		{
			timesecs++;
			if (timesecs == 60)
			{
				/* every minute: listen, if not already */
				listenp(PORT);
				timesecs=0;
			}
			/* every second */
			accept_socklisten_connections();
			last_db_in=db_in;
			last_db_out=db_out;
			kvm_updatestats();
			bcast();
			timelast = timenow;
		}
		/* every 10 miliseconds */
		get_sockdata();
		usleep(100000);
	}
	return 0;
}

/* KVM */

int kvm_test(void) {
  if (((kvmfd = kvm_open(NULL, NULL, NULL, O_RDONLY, buffer)) == NULL) || (kvm_nlist(kvmfd, symbols) < 0) || kvm_read(kvmfd, (unsigned long)symbols[0].n_value, &ifnet_savedaddr, sizeof(unsigned long)) == -1 ) return 0;
  printf("using KVM to monitor %s\n", DEVICE);
  return 1;
}

int kvm_updatestats(void) {
 struct ifnet * ifnet = (struct ifnet *)buffer;
 unsigned long ifnet_addr = ifnet_savedaddr;
 char devname[16];
 int flag = 0;
 unsigned long tp_in, tp_out, tb_in, tb_out;
 static unsigned long lp_in, lp_out, lb_in, lb_out;
 //static unsigned int dp_in, dp_out;

 while (ifnet_addr && flag != (ACCOUNT_IN_FOUND|ACCOUNT_OUT_FOUND)) {
  kvm_read(kvmfd, ifnet_addr, buffer, sizeof(struct ifnet));
#ifdef __OpenBSD__
  snprintf(devname, 15, "%s", ifnet->if_xname);
#else
  kvm_read(kvmfd, (unsigned long)ifnet->if_name, devname, 15);
  snprintf(devname, 15, "%s%d", devname, ifnet->if_unit);
#endif
   /* we found our struct */
  if(!strncmp(devname, DEVICE, DEVICE)) {
        tp_in =ifnet->if_ipackets;
        if (tp_in != lp_in) {
                tb_in = ifnet->if_ibytes;
                //dp_in += tp_in - lp_in;
                db_in += tb_in - lb_in;
                lp_in = tp_in;
                lb_in = tb_in;
                rx = 1;
        }
         
         
        tp_out =ifnet->if_opackets;
        if (tp_out != lp_out) {
                tb_out = ifnet->if_obytes;
                //dp_out += tp_out - lp_out;
                db_out += tb_out - lb_out;
                lp_out = tp_out;
                lb_out = tb_out;
                tx = 1;
        }
        flag = (ACCOUNT_IN_FOUND|ACCOUNT_OUT_FOUND);

  } else {
#ifdef __OpenBSD__
        ifnet_addr = (unsigned long)ifnet->if_list.tqe_next;
#else
        ifnet_addr = (unsigned long)ifnet->if_next;
#endif
  }
 }
 
 //return((id->rx == id->current_rx) && (id->tx == id->current_tx));
 return 1;
}

